'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _constants = require('../constants');

var _uuidV = require('uuid-v4');

var _uuidV2 = _interopRequireDefault(_uuidV);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (requestName, action) {
	if (typeof requestName === 'function') {
		action = requestName;
		requestName = null;
	}

	return function () {
		return _extends({}, action.apply(undefined, arguments), {

			__request: {
				name: requestName,
				id: (0, _uuidV2.default)(),
				status: _constants.BEGIN_REQUEST,
				timestamp: Date.now()
			},

			REQUEST_ACTION: true
		});
	};
};