import io from 'socket.io'
import { serverMiddleware } from '../src'

const server = io()

const actionHandler = ({action, resolve, reject}) => {
	console.log("\nRECEIVED_ACTION\n")
	// console.log(action)

	if (action.type == 'RESOLVE') {
		resolve()

		return resolve({
			type: "Another Action"
		})
	}

	reject("Rejected")
}

server.on('connect', client => serverMiddleware(client, actionHandler))

server.listen(2001)