'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _constants = require('../constants');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = function () {
	var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
	var action = arguments[1];
	var type = action.type,
	    __request = action.__request;

	var _ref = __request || {},
	    id = _ref.id;

	switch (type) {
		case _constants.BEGIN_REQUEST:
			{
				return _extends({}, state || {}, _defineProperty({}, id, __request));
			}

		case _constants.COMPLETE_REQUEST:
			{
				return _extends({}, state, _defineProperty({}, id, __request));
			}

		case _constants.FAIL_REQUEST:
			{
				return _extends({}, state, _defineProperty({}, id, __request));
			}
	}

	return state;
};